VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsArchiveBySevenZip32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************************************************
'   ZIPt@Ck^𓀋@\(7-ZIP32.DLLK{)                  clsArchiveBySevenZip32(Class)
'
'   쐬:㎡  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelłd!]
'***************************************************************************************************
'   [QƐݒ]
'   EMicrosoft Scripting Runtime
'   [ZIPkEDLL]
'   E7-ZIP32.dll (32rbgExcelɕKvł)
'   E7-ZIP64.dll (64rbgExcelɕKvł)
'***************************************************************************************************
' ύXt Rev   ύXe---------------------------------------------------------------------->
' 12/03/04(1.0.0)VK쐬
' 17/09/24(2.0.0)NXڍs(modArchiveBySevenZip32clsArchiveBySevenZip32)
' 17/09/30(2.0.0)kΏۃt@C̕w@\Ή(tH_̏ꍇ1̂)
' 19/10/28(2.1.0)DeclareLq̕ύX(64rbgExcelΉ7-ZIP64.DLLK{)
'***************************************************************************************************
Option Explicit
'===================================================================================================
Private Const g_cnsZIP As String = ".zip"
Private Const g_cnsEXE As String = ".exe"
'---------------------------------------------------------------------------------------------------
#If VBA7 And Win64 Then
Private Const g_cns7ZipName As String = "7-ZIP64"
' 7-ZIP64̃o[W擾(7-ZIP64)
Private Declare PtrSafe Function SevenZipGetVersion Lib "7-ZIP64.DLL" () As Integer
' 7-ZIP64̓ԂmF(7-ZIP64)
Private Declare PtrSafe Function SevenZipGetRunning Lib "7-ZIP64.DLL" () As Boolean
' ZIPk𑀍삷(7-ZIP64)
Private Declare PtrSafe Function SevenZip Lib "7-ZIP64.DLL" _
    (ByVal hWnd As LongPtr, _
     ByVal szCmdLine As String, _
     ByVal szOutput As String, _
     ByVal dwSize As Long) As Long
#Else
Private Const g_cns7ZipName As String = "7-ZIP32"
' 7-ZIP32̃o[W擾(7-ZIP32)
Private Declare Function SevenZipGetVersion Lib "7-ZIP32.DLL" () As Integer
' 7-ZIP32̓ԂmF(7-ZIP32)
Private Declare Function SevenZipGetRunning Lib "7-ZIP32.DLL" () As Boolean
' ZIPk𑀍삷(7-ZIP32)
Private Declare Function SevenZip Lib "7-ZIP32.DLL" _
    (ByVal hWnd As Long, _
     ByVal szCmdLine As String, _
     ByVal szOutput As String, _
     ByVal dwSize As Long) As Long
#End If
#If VBA7 Then
' EBhEnhԂ
Private Declare PtrSafe Function FindWindow Lib "USER32.dll" Alias "FindWindowA" _
    (ByVal lpClassName As Any, ByVal lpWindowName As Any) As LongPtr
#Else
' EBhEnhԂ
Private Declare Function FindWindow Lib "USER32.dll" Alias "FindWindowA" _
    (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long
#End If
'---------------------------------------------------------------------------------------------------
Private g_strWindowCaption As String                                ' eEBhE^Cg

'***************************************************************************************************
'    NX 
'***************************************************************************************************
'* @FClass_Initialize
'* @\@@FNX
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Ȃ)
'* @@F(Ȃ)
'---------------------------------------------------------------------------------------------------
'* 쐬@F2017N0924
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Sub Class_Initialize()
    '-----------------------------------------------------------------------------------------------
    ' EBhE݂Excel.Application^Cgɐݒ
    g_strWindowCaption = Application.Caption
End Sub

'***************************************************************************************************
'    ǑĂяovV[W(Friend) 
'***************************************************************************************************
'* @FArchiveByUNLHA32
'* @\@@FZIPt@Ck@\(7-ZIP32.dllK{)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = kΏۂ̃tH_^t@C(Variant) ̏ꍇ͔zZbg
'* @@@@@Arg2 = k̃t@C(String)              RefQ
'* @@@@@Arg3 = G[bZ[W(Atring)                RefQ
'* @@@@@Arg4 = t@Cɒǉ(Boolean)             Option
'* @@@@@Arg5 = pX[h(String)                      Option
'---------------------------------------------------------------------------------------------------
'* 쐬@F2012N0304
'* 쐬ҁ@F@
'* XV@F2017N0930
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function ArchiveBySevenZip32(ByRef vntSrcPath As Variant, _
                                    ByRef strZipFile As String, _
                                    ByRef strErrMSG As String, _
                                    Optional ByVal blnAppend As Boolean = False, _
                                    Optional ByVal strPassword As String = "") As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim objFso As FileSystemObject                                  ' FileSystemObject
    Dim strCommand As String                                        ' R}hC
    ArchiveBySevenZip32 = False
    Set objFso = New FileSystemObject
    '-----------------------------------------------------------------------------------------------
    ' kwlyъ`FbN(+R}hCҏW)
    If Not FP_CheckArchive(objFso, _
                           vntSrcPath, _
                           strZipFile, _
                           strCommand, _
                           strErrMSG) Then
        Set objFso = Nothing
        Exit Function
    End If
    '-----------------------------------------------------------------------------------------------
    ' skt@C폜
    If (objFso.FileExists(strZipFile) And Not blnAppend) Then
        On Error Resume Next
        objFso.DeleteFile strZipFile, True
        ' G[
        If Err.Number <> 0 Then
            strErrMSG = "o̓t@C̎O폜Ɏs܂B" & vbCrLf & Err.Description
            Err.Clear
            Set objFso = Nothing
            On Error GoTo 0
            Exit Function
        End If
        On Error GoTo 0
    End If
    Set objFso = Nothing
    '-----------------------------------------------------------------------------------------------
    ' R}hC̕ҏW(ZIPk)
    If strPassword <> "" Then
        strCommand = strCommand & " -p" & strPassword       ' pX[h
    End If
    strCommand = strCommand & " -mx=9 "                     ' k
    '-----------------------------------------------------------------------------------------------
    ' 7-ZIP32R}hC
    ArchiveBySevenZip32 = LetCommandSevenZip(strCommand, strErrMSG)
End Function

'***************************************************************************************************
'* @FExtractBySevenZip32
'* @\@@FZIPkt@C̉𓀋@\(7-ZIP32.dllK{)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = ZIPkt@C(String)
'* @@@@@Arg2 = 𓀐tH_(String)
'* @@@@@Arg3 = G[bZ[W(Atring)                RefQ
'* @@@@@Arg4 = ㏑w(Boolean)                     Option
'* @@@@@Arg5 = pX[h(String)                      Option
'---------------------------------------------------------------------------------------------------
'* 쐬@F2012N0304
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function ExtractBySevenZip32(ByVal strZipFile As String, _
                                    ByVal strDstPath As String, _
                                    ByRef strErrMSG As String, _
                                    Optional ByVal blnOverWrite As Boolean = False, _
                                    Optional ByVal strPassword As String = "") As Boolean
    '-----------------------------------------------------------------------------------------------
    ExtractBySevenZip32 = False
    ' 𓀎wlyъ`FbN
    If Not FP_CheckExtract(strZipFile, strDstPath, strErrMSG) Then Exit Function
    '-----------------------------------------------------------------------------------------------
    ' R}hC̕ҏW(ZIP)
    Dim strCommand As String
    strCommand = "x "                                       ' ZIP
    strCommand = strCommand & " """ & strZipFile & """"     ' kt@C
    strCommand = strCommand & " -o""" & strDstPath & """"   ' 𓀐tH_
    strCommand = strCommand & " *.* -r"                     ' Sĉ
    If blnOverWrite Then
        strCommand = strCommand & " -aoa"                   ' ㏑
    End If
    If strPassword <> "" Then
        strCommand = strCommand & " -p" & strPassword       ' pX[h
    End If
    '-----------------------------------------------------------------------------------------------
    ' 7-ZIP32R}hC
    ExtractBySevenZip32 = LetCommandSevenZip(strCommand, strErrMSG)
End Function

'***************************************************************************************************
'* @FLetCommandSevenZip
'* @\@@F7-ZIP32.DLL̃R}hCs
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = R}hC(String)
'* @@@@@Arg2 = G[bZ[W(Atring)                RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2012N0304
'* 쐬ҁ@F@
'* XV@F2019N1028
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function LetCommandSevenZip(ByVal strCommand As String, _
                                   ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
#If VBA7 Then
    Dim hWnd As LongPtr                                             ' EBhEnhl
#Else
    Dim hWnd As Long                                                ' EBhEnhl
#End If
    Dim strMSG_Base As String                                       ' bZ[Wx[X
    Dim strBuffer As String                                         ' Work
    LetCommandSevenZip = False
    On Error GoTo LetCommandSevenZip_ERROR
    '-----------------------------------------------------------------------------------------------
    strMSG_Base = "kR|[lg" & g_cns7ZipName & "CXg[Ă܂B"
    ' 7-ZIP32.dll̑݊mF(o[W擾s)
    Call SevenZipGetVersion
    '---------------------------------------------------------------------------
    strMSG_Base = "kR|[lg" & g_cns7ZipName & "œ쒆łB"
    ' 7-ZIP32.DLL̓ԊmF
    If SevenZipGetRunning() Then
        strErrMSG = strMSG_Base
        Exit Function
    End If
    DoEvents                    ' ꂪȂƓsɂȂ悤łH
    '---------------------------------------------------------------------------
    strMSG_Base = "" & g_cns7ZipName & "Ɏs܂B"
    ' EBhEnh擾
    hWnd = FP_GetWindowHwnd
    strBuffer = String(256, Chr(0))
    ' 7-ZIP32.DLL̃R}hCs
    If SevenZip(hWnd, strCommand, strBuffer, Len(strBuffer)) = 0& Then
        LetCommandSevenZip = True
    Else
        strErrMSG = Left(strBuffer, InStr(1, strBuffer, Chr(0)) - 1)
    End If
    On Error GoTo 0
    Exit Function
    
'===================================================================================================
LetCommandSevenZip_ERROR:
    strErrMSG = strMSG_Base & vbCrLf & Err.Description
    On Error GoTo 0
End Function

'***************************************************************************************************
'    Tu(Private) 
'***************************************************************************************************
'* @FFP_CheckArchive
'* @\@@Fkwlyъ`FbN(+R}hCҏW)
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = FileSystemObject(Object)
'* @@@@@Arg2 = kΏۂ̃t@C(Variant)       ̏ꍇ͔zZbg
'* @@@@@Arg3 = k̃t@C(String)          RefQ
'* @@@@@Arg4 = ҏWR}hC(String)      RefQ
'* @@@@@Arg5 = G[bZ[W(String)            RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2017N0924
'* 쐬ҁ@F@
'* XV@F2017N0930
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Function FP_CheckArchive(ByRef objFso As FileSystemObject, _
                                 ByRef vntSrcPath As Variant, _
                                 ByRef strZipFile As String, _
                                 ByRef strCommand As String, _
                                 ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim lngIx As Long                                               ' e[uINDEX
    Dim strPathname As String                                       ' tH_(Work)
    Dim strFilename As String                                       ' t@C(Work)
    Dim strExtL As String                                           ' gq()
    FP_CheckArchive = False
    '-----------------------------------------------------------------------------------------------
    ' kt@C`FbN
    strFilename = Trim(strZipFile)
    ' uN
    If strFilename = "" Then
        strErrMSG = "o̓t@Cw肳Ă܂B"
        Exit Function
    End If
    ' tpXłȂΖ{ubÑtH_w
    If ((Left$(strFilename, 2) <> "\\") And (Mid$(strFilename, 2, 2) <> ":\")) Then
        strPathname = ThisWorkbook.Path
        strZipFile = objFso.BuildPath(strPathname, strFilename)
    Else
        strZipFile = strFilename
        strFilename = objFso.GetFileName(strZipFile)
        strPathname = Left$(strZipFile, Len(strZipFile) - Len(strFilename) - 1)
    End If
    ' tH_݂邩
    If Not objFso.FolderExists(strPathname) Then
        strErrMSG = "o̓t@C̃tB_݂܂B" & vbCrLf & strPathname
        Exit Function
    End If
    strExtL = LCase(Right(strZipFile, 4))                            ' gq
    ' gq̔(w̏ꍇ͋Iɕt)
    If ((strExtL <> g_cnsZIP) And (strExtL <> g_cnsEXE)) Then
        strZipFile = strZipFile & g_cnsZIP
        strFilename = strFilename & g_cnsZIP
    End If
    '-----------------------------------------------------------------------------------------------
    ' R}hC̕ҏW(ZIPk)Jn
    strCommand = "a -tzip"                                  ' ZIP`l
    strCommand = strCommand & " """ & strZipFile & """"     ' kt@C
    '-----------------------------------------------------------------------------------------------
    ' kΏۃt@C`FbN
    If IsArray(vntSrcPath) Then
        lngIx = 0
        ' t@Cw(tH_ɂ͑ΉĂȂ)
        Do While lngIx <= UBound(vntSrcPath)
            strFilename = Trim(vntSrcPath(lngIx))
            ' ݊mF
            If Not objFso.FileExists(strFilename) Then
                strErrMSG = "̓t@C݂܂B" & vbCrLf & strFilename
                Exit Function
            Else
                strCommand = strCommand & " """ & strFilename & """"
            End If
            ' ̃t@C
            lngIx = lngIx + 1
        Loop
    Else
        strFilename = Trim(vntSrcPath)
        ' w肩
        If strFilename = "" Then
            strErrMSG = "̓t@Cw肳Ă܂B"
            Exit Function
        ElseIf objFso.FolderExists(strFilename) Then
            ' tH_w̏ꍇ͔zSĂi[
            strCommand = strCommand & " """ & strFilename & "\*"""
        ElseIf objFso.FileExists(strFilename) Then
            ' t@Cw
            strCommand = strCommand & " """ & strFilename & """"
        Else
            ' ws
            strErrMSG = "̓t@C݂܂B" & vbCrLf & strFilename
            Exit Function
        End If
    End If
    '-----------------------------------------------------------------------------------------------
    FP_CheckArchive = True
End Function

'***************************************************************************************************
'* @FFP_CheckExtract
'* @\@@F𓀎wlyъ`FbN
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = ZIPkt@C(String)
'* @@@@@Arg2 = 𓀐tH_(String)
'* @@@@@Arg3 = G[bZ[W(String)            RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2017N0924
'* 쐬ҁ@F@
'* XV@F2017N0924
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Private Function FP_CheckExtract(ByVal strZipFile As String, _
                                 ByVal strDstPath As String, _
                                 ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim objFso As FileSystemObject                                  ' FileSystemObject
    FP_CheckExtract = False
    '-----------------------------------------------------------------------------------------------
    ' kt@C̑݊mF
    If Trim(strZipFile) = "" Then
        strErrMSG = "ZIPkt@Cw肳Ă܂B"
        Exit Function
    ElseIf LCase(Right(strZipFile, 4)) <> g_cnsZIP Then
        strErrMSG = "ZIPkt@Č`Ă܂B"
        Exit Function
    ElseIf Trim(strDstPath) = "" Then
        strErrMSG = "𓀐tH_w肳Ă܂B"
        Exit Function
    End If
    Set objFso = New FileSystemObject
    On Error Resume Next
    If Not objFso.FileExists(strZipFile) Then
        strErrMSG = "ZIPkt@C݂܂B"
        Set objFso = Nothing
        On Error GoTo 0
        Exit Function
    End If
    If Err.Number <> 0 Then
        strErrMSG = "ZIPkt@CQƂł܂B" & vbCrLf & Err.Description
        Err.Clear
        Set objFso = Nothing
        On Error GoTo 0
        Exit Function
    End If
    '-----------------------------------------------------------------------------------------------
    ' 𓀐tH_̑݊mF
    If Not objFso.FolderExists(strDstPath) Then
        strErrMSG = "𓀐tH_݂܂B"
        Set objFso = Nothing
        On Error GoTo 0
        Exit Function
    End If
    If Err.Number <> 0 Then
        strErrMSG = "𓀐tH_QƂł܂B" & vbCrLf & Err.Description
        Err.Clear
        Set objFso = Nothing
        On Error GoTo 0
        Exit Function
    End If
    Set objFso = Nothing
    On Error GoTo 0
    FP_CheckExtract = True
End Function

'***************************************************************************************************
'* @FFP_GetWindowHwnd
'* @\@@FEBhEnh擾
'---------------------------------------------------------------------------------------------------
'* Ԃl@FEBhEnh(Long)
'* @@F(Ȃ)
'---------------------------------------------------------------------------------------------------
'* 쐬@F2012N0304
'* 쐬ҁ@F@
'* XV@F2019N1028
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
#If VBA7 Then
Private Function FP_GetWindowHwnd() As LongPtr
    '-----------------------------------------------------------------------------------------------
    ' ExcelEBhE
    Select Case g_strWindowCaption
        Case "", Application.Caption
            ' ExcelEBhEƔf
            FP_GetWindowHwnd = Application.hWnd
        Case Else
            ' [U[tH[Ɣf
            On Error Resume Next
            FP_GetWindowHwnd = FindWindow("ThunderDFrame", g_strWindowCaption)
            ' G[ExcelEBhEƔf
            If Err.Number <> 0 Then
                FP_GetWindowHwnd = Application.hWnd
            End If
            On Error GoTo 0
    End Select
End Function
#Else
Private Function FP_GetWindowHwnd() As Long
    '-----------------------------------------------------------------------------------------------
    ' ExcelEBhE
    Select Case g_strWindowCaption
        Case "", Application.Caption
            ' ExcelEBhEƔf
            FP_GetWindowHwnd = Application.hWnd
        Case Else
            ' [U[tH[Ɣf
            On Error Resume Next
            FP_GetWindowHwnd = FindWindow("ThunderDFrame", g_strWindowCaption)
            ' G[ExcelEBhEƔf
            If Err.Number <> 0 Then
                FP_GetWindowHwnd = Application.hWnd
            End If
            On Error GoTo 0
    End Select
End Function
#End If

'***************************************************************************************************
'    vpeB 
'***************************************************************************************************
'   eEBhE^Cg(String)
'---------------------------------------------------------------------------------------------------
Friend Property Let prpWindowCaption(ByVal Value As String)
    '-----------------------------------------------------------------------------------------------
    g_strWindowCaption = Value
End Property

'------------------------------------------<< End of Source >>--------------------------------------

